import { renderless, api } from "@xmweb-ui/vue-renderless/split/vue";
import { defineComponent, props, setup as _setup } from "@xmweb-ui/vue-common";
import { iconChevronRight } from "@xmweb-ui/vue-icon";
import { resolveComponent, openBlock, createElementBlock, normalizeClass, createElementVNode, normalizeStyle, renderSlot, setBlockTracking, Fragment, renderList, createVNode, createCommentVNode } from "vue";
function _createForOfIteratorHelperLoose(o, allowArrayLike) {
  var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];
  if (it)
    return (it = it.call(o)).next.bind(it);
  if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
    if (it)
      o = it;
    var i = 0;
    return function() {
      if (i >= o.length)
        return { done: true };
      return { done: false, value: o[i++] };
    };
  }
  throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _unsupportedIterableToArray(o, minLen) {
  if (!o)
    return;
  if (typeof o === "string")
    return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor)
    n = o.constructor.name;
  if (n === "Map" || n === "Set")
    return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))
    return _arrayLikeToArray(o, minLen);
}
function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length)
    len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++)
    arr2[i] = arr[i];
  return arr2;
}
var _export_sfc = function _export_sfc2(sfc, props) {
  var target = sfc.__vccOpts || sfc;
  for (var _iterator = _createForOfIteratorHelperLoose(props), _step; !(_step = _iterator()).done; ) {
    var _step$value = _step.value, key = _step$value[0], val = _step$value[1];
    target[key] = val;
  }
  return target;
};

var _sfc_main = defineComponent({
  emits: ["moving", "mousemove", "mouseup", "moveend", "movestart", "update:modelValue", "collapsedChange"],
  props: [].concat(props, ["modelValue", "mode", "leftTopMin", "rightBottomMin", "collapsible"]),
  components: {
    IconChevronRight: iconChevronRight()
  },
  setup: function setup(props2, context) {
    return _setup({
      props: props2,
      context,
      renderless,
      api
    });
  }
});
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_icon_chevron_right = resolveComponent("icon-chevron-right");
  return openBlock(), createElementBlock(
    "div",
    {
      ref: "outerWrapper",
      class: normalizeClass(_ctx.state.wrapperClasses)
    },
    [_ctx.state.isHorizontal ? (openBlock(), createElementBlock(
      "div",
      {
        key: 0,
        class: normalizeClass(_ctx.state.prefix + "-horizontal")
      },
      [createElementVNode(
        "div",
        {
          style: normalizeStyle({
            right: _ctx.state.collapsed ? "100%" : _ctx.state.anotherOffset + "%"
          }),
          class: normalizeClass([_ctx.state.paneClasses, "left-pane"])
        },
        [renderSlot(_ctx.$slots, "left")],
        6
        /* CLASS, STYLE */
      ), createElementVNode(
        "div",
        {
          class: normalizeClass(_ctx.state.prefix + "-trigger-con"),
          style: normalizeStyle({
            left: _ctx.state.collapsed ? "2px" : _ctx.state.offset + "%"
          }),
          onMousedown: _cache[1] || (_cache[1] = function() {
            return _ctx.handleMousedown && _ctx.handleMousedown.apply(_ctx, arguments);
          })
        },
        [renderSlot(_ctx.$slots, "trigger", {}, function() {
          return [createElementVNode(
            "div",
            {
              class: normalizeClass([_ctx.state.prefix + "-trigger", _ctx.state.prefix + "-trigger-vertical"])
            },
            [createElementVNode(
              "div",
              {
                class: normalizeClass([_ctx.state.prefix + "-trigger-bar-con", "vertical"])
              },
              [_cache[0] || (setBlockTracking(-1), _cache[0] = (openBlock(), createElementBlock(
                Fragment,
                null,
                renderList(3, function(i) {
                  return createElementVNode(
                    "i",
                    {
                      class: normalizeClass(_ctx.state.prefix + "-trigger-bar"),
                      key: "trigger-" + i
                    },
                    null,
                    2
                    /* CLASS */
                  );
                }),
                64
                /* STABLE_FRAGMENT */
              )), setBlockTracking(1), _cache[0])],
              2
              /* CLASS */
            )],
            2
            /* CLASS */
          )];
        })],
        38
        /* CLASS, STYLE, HYDRATE_EVENTS */
      ), _ctx.collapsible ? (openBlock(), createElementBlock(
        "div",
        {
          key: 0,
          class: normalizeClass(_ctx.state.prefix + "-collapse-bar"),
          style: normalizeStyle({
            left: _ctx.state.collapsed ? 0 : "calc(" + _ctx.state.offset + "% - 2px)"
          }),
          onClick: _cache[2] || (_cache[2] = function() {
            return _ctx.handleCollapse && _ctx.handleCollapse.apply(_ctx, arguments);
          })
        },
        [createVNode(_component_icon_chevron_right, {
          style: normalizeStyle({
            transform: "rotate(" + (_ctx.state.collapsed ? "0deg" : "180deg") + ")"
          })
        }, null, 8, ["style"])],
        6
        /* CLASS, STYLE */
      )) : createCommentVNode("v-if", true), createElementVNode(
        "div",
        {
          style: normalizeStyle({
            left: _ctx.state.collapsed ? "0" : _ctx.state.offset + "%"
          }),
          class: normalizeClass([_ctx.state.paneClasses, "right-pane"])
        },
        [renderSlot(_ctx.$slots, "right")],
        6
        /* CLASS, STYLE */
      )],
      2
      /* CLASS */
    )) : (openBlock(), createElementBlock(
      "div",
      {
        key: 1,
        class: normalizeClass(_ctx.state.prefix + "-vertical")
      },
      [createElementVNode(
        "div",
        {
          style: normalizeStyle({
            bottom: _ctx.state.collapsed ? "100%" : _ctx.state.anotherOffset + "%"
          }),
          class: normalizeClass([_ctx.state.paneClasses, "top-pane"])
        },
        [renderSlot(_ctx.$slots, "top")],
        6
        /* CLASS, STYLE */
      ), createElementVNode(
        "div",
        {
          class: normalizeClass(_ctx.state.prefix + "-trigger-con"),
          style: normalizeStyle({
            top: _ctx.state.collapsed ? "2px" : _ctx.state.offset + "%"
          }),
          onMousedown: _cache[4] || (_cache[4] = function() {
            return _ctx.handleMousedown && _ctx.handleMousedown.apply(_ctx, arguments);
          })
        },
        [renderSlot(_ctx.$slots, "trigger", {}, function() {
          return [createElementVNode(
            "div",
            {
              class: normalizeClass([_ctx.state.prefix + "-trigger", _ctx.state.prefix + "-trigger-horizontal"])
            },
            [createElementVNode(
              "div",
              {
                class: normalizeClass([_ctx.state.prefix + "-trigger-bar-con", "horizontal"])
              },
              [_cache[3] || (setBlockTracking(-1), _cache[3] = (openBlock(), createElementBlock(
                Fragment,
                null,
                renderList(3, function(i) {
                  return createElementVNode(
                    "i",
                    {
                      class: normalizeClass(_ctx.state.prefix + "-trigger-bar"),
                      key: "trigger-" + i
                    },
                    null,
                    2
                    /* CLASS */
                  );
                }),
                64
                /* STABLE_FRAGMENT */
              )), setBlockTracking(1), _cache[3])],
              2
              /* CLASS */
            )],
            2
            /* CLASS */
          )];
        })],
        38
        /* CLASS, STYLE, HYDRATE_EVENTS */
      ), _ctx.collapsible ? (openBlock(), createElementBlock(
        "div",
        {
          key: 0,
          class: normalizeClass(_ctx.state.prefix + "-collapse-bar"),
          style: normalizeStyle({
            top: _ctx.state.collapsed ? 0 : "calc(" + _ctx.state.offset + "% - 2px)"
          }),
          onClick: _cache[5] || (_cache[5] = function() {
            return _ctx.handleCollapse && _ctx.handleCollapse.apply(_ctx, arguments);
          })
        },
        [createVNode(_component_icon_chevron_right, {
          style: normalizeStyle({
            transform: "rotate(" + (_ctx.state.collapsed ? "90deg" : "270deg") + ")"
          })
        }, null, 8, ["style"])],
        6
        /* CLASS, STYLE */
      )) : createCommentVNode("v-if", true), createElementVNode(
        "div",
        {
          style: normalizeStyle({
            top: _ctx.state.collapsed ? "0" : _ctx.state.offset + "%"
          }),
          class: normalizeClass([_ctx.state.paneClasses, "bottom-pane"])
        },
        [renderSlot(_ctx.$slots, "bottom")],
        6
        /* CLASS, STYLE */
      )],
      2
      /* CLASS */
    ))],
    2
    /* CLASS */
  );
}
var pc = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render]]);
export {
  pc as default
};
